//
// C++ Interface: sniffer
//
// Description: Class used in mulot to read tcpdump files.
//
//
//     Copyright (C) 2008  Romain Fontugne <romain.fontugne@gmail.com>
//
//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef SNIFFER_H
#define SNIFFER_H

#include <iostream>
#include <algorithm>
#include <vector>
#include <pcap.h>
using namespace std;

class Sniffer{
public:
    Sniffer();
    Sniffer(int argc, FILE *fd[],char *fCode);
    int init();
    ~Sniffer();

    int loop(pcap_handler callback, u_char *userData, char noFile=0, int offset=0);

    void breakloop();

    char	**files;
    int		nbFiles;
    char	fileInd;
    char	*code;
    pcap_t	*currPcapDesc;
    pcap_t	**pcapDesc;
    int		initOffset;
};

#endif
